<template>
    <div class="content-grid content-grid--subpage">
      <Breadcrumbs :title=messRoutes />
      <BackLinkTitle :title=backLinkTitle />
        <Card>
            <CoursForm :cours="cours" @formSubmit="handleSubmit" />
        </Card>
    </div>
</template>

<script lang="ts" setup>
    import CoursForm from "@/components/cours/CoursForm.vue";
    import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
    import Card from "@/components/layout/Card.vue";
    import { useI18n } from "vue3-i18n";
    import { Cours } from "@/types/entities/cours";
    import { notifyError, notifySuccess } from "@/notify";
    import { useCoursService } from "@/inversify.config";
    import { IEditCoursRequest } from "@/types/requests/editCoursRequest";
    import { useRouter,useRoute } from "vue-router";
    import { ref } from "vue";
    import BackLinkTitle from "@/components/layout/BackLinkTitle.vue";

    const { t } = useI18n()
    const messRoutes = "Cours / Consultation des cours / Modification du cours";
    const backLinkTitle = "Modification du cours";
    const router = useRouter();
    const route = useRoute();
    const coursService = useCoursService();
    const id = route.params.id.toString();
    const cours = ref<Cours>(await coursService.getCours(id))
    async function handleSubmit(cours: Cours) {
        let succeededOrNotResponse = await coursService.editCours(cours as IEditCoursRequest)
        if (succeededOrNotResponse && succeededOrNotResponse.succeeded) {
            notifySuccess(t('validation.cours.edit.success'))
            setTimeout(() => {
                router.back();
            }, 1500);
        } else {
          notifyError(succeededOrNotResponse.errors[0].errorMessage);
        }
    }
</script>